unit HalReg;

interface
uses classes,sysutils,dsgnintf,db,dbtables,typinfo,HalComp,qbinddlg;
{---------------------------------}
{$IFNDEF VER80}
  {$IFNDEF VER90}
    {$DEFINE USED3} { Delphi 3.0 or higher }
  {$ENDIF}
{$ENDIF}


{R HALREG.DCR}
type
  TMethodsProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings); virtual;
    procedure GetValues(Proc: TGetStrProc); override;
    function Getvname:String;virtual;
  end;

  TParamsProperty = class(TPropertyEditor)
  public
    function GetValue: string; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TParCOmpParamsProperty = class(TParamsProperty)
    procedure Edit; override;
  end;
{---------------------------------}
procedure Register;
{---------------------------------}
implementation
{-------------------------------------------}
procedure TParCOmpParamsProperty.Edit;
var
  List: TParams;
  SGO: TParComp;
  Query:TQuery;
begin
 try
  SGO := GetComponent(0) as TParComp;
  Query:=TQuery.Create(SGO);

  Query.DatabaseName := 'DBNAME';
  Query.SQL := SGO.Script;
  Query.Params := SGO.Params;
  List := TParams.Create;
  try
    List.Assign(SGO.Params);
    if EditQueryParams(Query, List) then begin
     SGO.Params := List;
     if Designer <> nil then Designer.Modified;
    end;
  finally
    List.Free;
  end;
 finally
  Query.Free;
 end;
end;

{------------------------------------}
function TParamsProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog];
end;
{------------------------------------}
function TParamsProperty.GetValue: string;
begin
  Result := '(Parameters)';
end;
{------------------------------------}
function TMethodsProperty.Getvname:String;
begin
Result:='ControlLink';
end;
{------------------------------------}
procedure TMethodsProperty.GetValueList(List: TStrings);
var
  Instance: TComponent;
  PropInfo: PPropInfo;
  mc:tcomponent;
  maxp,i:integer;
  proplist:array[0..1000] of PPropInfo;
begin
 List.BeginUpdate;
 List.Clear;
  Instance := TComponent(GetComponent(0));
  PropInfo := TypInfo.GetPropInfo(Instance.ClassInfo,getvname);

  if (PropInfo <> nil) and (PropInfo^.PropType^.Kind = tkClass) then
  begin
    mc := TObject(GetOrdProp(Instance, PropInfo)) as TComponent;
    if (mc=nil) then mc:=Instance.Owner;
    if (mc <> nil) then begin
    maxp:=GetPropList(mc.classinfo,tkmethods,@PropList);
    for i:=0 to maxp-1 do
     if CompareText(proplist[i]^.proptype^.name,'TNotifyEvent')=0 then
    List.Add(proplist[i]^.name{+':'+proplist[i]^.proptype.name});
    end;
  end;
List.EndUpdate;
end;
{------------------------------------}
function TMethodsProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList,paSortList, paMultiSelect];
end;
{------------------------------------}
procedure TMethodsProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;
{---------------------------------}
procedure Register;
begin
 RegisterComponents('Kurin', [TParComp,THalComp]);
 RegisterPropertyEditor(typeinfo(string),thalcomp,'EventLink',TMethodsProperty);
 RegisterPropertyEditor(TypeInfo(TParams), TParCOmp, 'Params', TPArCompParamsProperty);
end;
{---------------------------------}
end.
